from random import randrange, shuffle

from model.card import Card, Value, Color


class Deck:
    def __init__(self):
        self.cards = [Card(v, c) for v in Value for c in Color]
        self.defausse = []

    def __len__(self):
        return len(self.cards)

    def random_card(self) -> Card:
        if not self.cards:
            self.reset()

        card = self.cards.pop(randrange(len(self.cards)))
        self.defausse.append(card)
        return card

    def reset(self):
        self.cards.extend(self.defausse)
        self.defausse.clear()
        shuffle(self.cards)